///////
// TEST:
//

#pragma once

#include "incls_all.hpp"

namespace rw::pingpong {

//------------------------------------------------------------------------------
class Pang_b : public RW {
 public:
  Pang_b();                                      // default ctor
  explicit Pang_b(std::string const& name_tag);  // tag-parm'd ctor

  auto t_tag() const -> Tip const&;

 private:
  Tip const tip_tag{};
};

//------------------------------------------------------------------------------
class Pang : public Pang_b {
 public:
  Pang();                                      // default ctor
  explicit Pang(std::string const& name_tag);  // tag-parm'd ctor

  // TEST:
  void ask(std::string const& query) const;
  auto tell() const -> std::string;

  inline auto my_peng() const -> Peng& { return peng; }
  inline auto my_ping() const -> Ping& { return ping; }
  inline auto my_pong() const -> Pong& { return pong; }

 private:
  unique_ptr<Peng_b> peng_{make_unique<Peng_b>("pang_peng")};
  unique_ptr<Ping_b> ping_{make_unique<Ping_b>("pang_ping")};
  unique_ptr<Pong_b> pong_{make_unique<Pong_b>("pang_pong")};

  Peng& peng{reference_to<Peng>(peng_.get())};
  Ping& ping{reference_to<Ping>(ping_.get())};
  Pong& pong{reference_to<Pong>(pong_.get())};
};

}  // namespace rw::pingpong

// v211121
