///////
// TEST:
//

#pragma once

#include "incls_all.hpp"

namespace rw::pingpong {

//------------------------------------------------------------------------------
class Peng_b : public RW {
 public:
  Peng_b();                                      // default ctor
  explicit Peng_b(std::string const& name_tag);  // tag-parm'd ctor

  auto t_tag() const -> Tip const&;

 private:
  Tip const tip_tag{};
};

//------------------------------------------------------------------------------
class Peng : public Peng_b {
 public:
  Peng();                                      // default ctor
  explicit Peng(std::string const& name_tag);  // tag-parm'd ctor

  // TEST:
  void ask(std::string const& query) const;
  auto tell() const -> std::string;

  inline auto my_pang() const -> Pang& { return pang; }
  inline auto my_ping() const -> Ping& { return ping; }
  inline auto my_pong() const -> Pong& { return pong; }

 private:
  unique_ptr<Pang_b> pang_{make_unique<Pang_b>("peng_pang")};
  unique_ptr<Ping_b> ping_{make_unique<Ping_b>("peng_ping")};
  unique_ptr<Pong_b> pong_{make_unique<Pong_b>("peng_pong")};

  Pang& pang{reference_to<Pang>(pang_.get())};
  Ping& ping{reference_to<Ping>(ping_.get())};
  Pong& pong{reference_to<Pong>(pong_.get())};
};

}  // namespace rw::pingpong

// v211121
