///////
// TEST:
//

#pragma once

#include "incls_all.hpp"

namespace rw::pingpong {

//------------------------------------------------------------------------------
class Ping_b : public RW {
 public:
  Ping_b();                                      // default ctor
  explicit Ping_b(std::string const& name_tag);  // tag-parm'd ctor

  auto t_tag() const -> Tip const&;

 private:
  Tip const tip_tag{};
};

//------------------------------------------------------------------------------
class Ping : public Ping_b {
 public:
  Ping();                                      // default ctor
  explicit Ping(std::string const& name_tag);  // tag-parm'd ctor

  // TEST:
  auto do_ping() const -> int;
  auto do_pong() const -> int;

  // TEST:
  void ask(std::string const& query) const;
  auto tell() const -> std::string;

  inline auto my_pang() const -> Pang& { return pang; }
  inline auto my_peng() const -> Peng& { return peng; }
  inline auto my_pong() const -> Pong& { return pong; }

 private:
  unique_ptr<Pang_b> pang_{make_unique<Pang_b>("ping_pang")};
  unique_ptr<Peng_b> peng_{make_unique<Peng_b>("ping_peng")};
  unique_ptr<Pong_b> pong_{make_unique<Pong_b>("ping_pong")};

  Pang& pang{reference_to<Pang>(pang_.get())};
  Peng& peng{reference_to<Peng>(peng_.get())};
  Pong& pong{reference_to<Pong>(pong_.get())};
};

}  // namespace rw::pingpong

// v211121
