///////
// TEST:
//

#pragma once

#include "incls_all.hpp"

namespace rw::pingpong {

//------------------------------------------------------------------------------
class Pong_b : public RW {
 public:
  Pong_b();                                      // default ctor
  explicit Pong_b(std::string const& name_tag);  // tag-parm'd ctor

  auto t_tag() const -> Tip const&;

 private:
  Tip const tip_tag{};
};

//------------------------------------------------------------------------------
class Pong : public Pong_b {
 public:
  Pong();                                      // default ctor
  explicit Pong(std::string const& name_tag);  // tag-parm'd ctor

  // TEST:
  auto do_ping() const -> int;
  auto do_pong() const -> int;

  // TEST:
  void ask(std::string const& query) const;
  auto tell() const -> std::string;

  inline auto my_pang() const -> Pang& { return pang; }
  inline auto my_peng() const -> Peng& { return peng; }
  inline auto my_ping() const -> Ping& { return ping; }

 private:
  unique_ptr<Pang_b> pang_{make_unique<Pang_b>("pong_pang")};
  unique_ptr<Peng_b> peng_{make_unique<Peng_b>("pong_peng")};
  unique_ptr<Ping_b> ping_{make_unique<Ping_b>("pong_ping")};

  Pang& pang{reference_to<Pang>(pang_.get())};
  Peng& peng{reference_to<Peng>(peng_.get())};
  Ping& ping{reference_to<Ping>(ping_.get())};
};

}  // namespace rw::pingpong

// v211121
