#pragma once

#include "incls_all.hpp"

namespace rw {

//------------------------------------------------------------------------------
/** The master base class from which all other tagged rw:: classes should derive
 * @note:
 */
class RW {
 public:
  /** Construct a @c RW object
   * @note default ctor
   */
  RW();

  /**
   * @param tag
   */
  RW(std::string const& name_tag);

  ~RW();

  /**
   * @return
   */
  auto my_tag() const -> std::string;

  /**
   * @return
   */
  auto my_id() const -> unsigned int;

  /**
   * @return
   */
  auto my_addr() const -> RW*;

  /** RW object's Tip 'tag'
   * @note: sending/receiving these is our primary means for tracing callgraphs
   * @return the object's Tip
   */
  auto full_tag() const -> Tip const&;

 private:
  /** Incremented by one for each new instance of this base class, as created
   */
  static unsigned long rw_id;

  /** ID's & ptrs are unique, but the tags are identical among the same types.
   * @note: eg; {sumomo.0}, {sumomo.1}, {arigato.2}, {dollhouse.3}, {arigato.4}
   */
  Tip const tip_;
};

}  // namespace rw

// v211121
