///////
// TEST:
//

#include "incls_all.hpp"

//------------------------------------------------------------------------------
int main() try {
  puts("\nPing Pong...\n");  // TRACE:

  /// TEST: Every object's t_tag is unique within the system

  Pang pang{"pang"};
  prt_tag(pang.t_tag(), "pang.t_tag()");
  prt_tag(pang.my_peng().t_tag(), "pang.my_peng().t_tag()");
  prt_tag(pang.my_ping().t_tag(), "pang.my_ping().t_tag()");
  prt_tag(pang.my_pong().t_tag(), "pang.my_pong().t_tag()");

  Peng peng{"peng"};
  prt_tag(peng.t_tag(), "peng.t_tag()");
  prt_tag(peng.my_pang().t_tag(), "peng.my_pang().t_tag()");
  prt_tag(peng.my_ping().t_tag(), "peng.my_ping().t_tag()");
  prt_tag(peng.my_pong().t_tag(), "peng.my_pong().t_tag()");

  Ping ping{"ping"};
  prt_tag(ping.t_tag(), "ping.t_tag()");
  prt_tag(ping.my_pang().t_tag(), "ping.my_pang().t_tag()");
  prt_tag(ping.my_peng().t_tag(), "ping.my_peng().t_tag()");
  prt_tag(ping.my_pong().t_tag(), "ping.my_pong().t_tag()");

  Pong pong{"pong"};
  prt_tag(pong.t_tag(), "pong.t_tag()");
  prt_tag(pong.my_pang().t_tag(), "pong.my_pang().t_tag()");
  prt_tag(pong.my_peng().t_tag(), "pong.my_peng().t_tag()");
  prt_tag(pong.my_ping().t_tag(), "pong.my_ping().t_tag()");

  /// TEST: Base-class indirection avoids an 'infinite member-objects' cycle

  cout << "\nping.do_ping() '" << ping.do_ping() << "'\n";
  cout << "ping.do_pong() '" << ping.do_pong() << "'\n";

  cout << "pong.do_ping() '" << pong.do_ping() << "'\n";
  cout << "pong.do_pong() '" << pong.do_pong() << "'\n";

  /// TEST: Working callgraph chain, 4-deep

  pang.ask("Is Chobits just an urban legend circulating the net?");
  cout << "\npang.tell() '" << pang.tell() << "'\n";

  puts("\n...Pong Ping\n");  // TRACE:
} catch (exception const& e) {
  // TBD:
} catch (...) {
  // TBD:
}

/*
-NOTE: When built using Mesonbuid, this project must be run in 'release' mode to
succeed. If for some reason it crashes on you, then you've probably gotten into
some other build mode (checkable as the 'buildtype' by issuing 'meson configure'
from the project's ./build/ dir).

-If so, just run this command from a terminal in the project's base directory:

cd build/ && meson configure -Dbuildtype=release && cd ..

*/

// v211121
