///////
// TEST:
//

#include "incls_all.hpp"

// TEST: External, TU-scoped class functions & data for rw:: class' to call into
//------------------------------------------------------------------------------
class Foo {
 public:
  std::string result{};
} foo{};  // instantiate a test object as well.

namespace rw::pingpong {

//------------------------------------------------------------------------------
Pong_b::Pong_b() : Pong_b{"pong_b_obj"} {}

//------------------------------------------------------------------------------
Pong_b::Pong_b(std::string const& name_tag)
    : RW{name_tag}, tip_tag{full_tag()} {}

//------------------------------------------------------------------------------
auto Pong_b::t_tag() const -> Tip const& {
  return tip_tag;
}

//------------------------------------------------------------------------------
Pong::Pong() : Pong{"pong_obj"} {}

//------------------------------------------------------------------------------
Pong::Pong(std::string const& name_tag) : Pong_b{name_tag} {}

// TEST:
//------------------------------------------------------------------------------
auto Pong::do_ping() const -> int {
  return 42;
}

// TEST:
//------------------------------------------------------------------------------
auto Pong::do_pong() const -> int {
  return ping.do_ping();
}

// TEST: end-of-callgraph-chain
//------------------------------------------------------------------------------
void Pong::ask(const std::string& query) const {
  foo.result = query;
}

// TEST: end-of-callgraph-chain
//------------------------------------------------------------------------------
auto Pong::tell() const -> std::string {
  return foo.result;
}

}  // namespace rw::pingpong

// v211121
